import es, string, popuplib, gamethread, os

###START EDITING###
# HE Grenade effect - use "none" for no effect.
effect_hegrenade = es.ServerVar("effect_hegrenade", "smoke")

# Flashbang effect - use "none" for no effect.
effect_flashbang = es.ServerVar("effect_flashbang", "energy")

# Smoke grenade effect - use "none" for no effect.
effect_smokegrenade = es.ServerVar("effect_smokegrenade", "beam")
###################

es.ServerVar("nadetrail_ver", "1.3", "The version of NadeTrail you are running!")
effects = ["beam", "smoke", "energy", "sparks", "beacon", "beamfollow"]
grenades = ["hegrenade", "smokegrenade", "flashbang"]
locations = {}
entities = {}

def load():
    es.addons.registerTickListener(ticklistener)

def unload():
    es.addons.unregisterTickListener(ticklistener)

def player_say(event_var):
    if event_var["text"].lower() == "!nadetrail":
        help(event_var["userid"])

def createeffect(index, grenade):
    global locations
    effect = es.ServerVar("effect_%s" % grenade)
    location = es.getindexprop(index, "CBaseEntity.m_vecOrigin")
    if not index in locations:
        locations[index] = location
    ####EFFECTS####
    if effect == "beamfollow":
        es.server.cmd("est_effect_04 #a!b 0.0 sprites/laser.vmt %s 2.0 40 40 0.5 255 0 0 200" % index)
    if effect == "smoke":
        es.effect("smoke", es.getindexprop(index, "CBaseEntity.m_vecOrigin"), "smoke", 5, 0.1)
    if effect == "energy":
        es.effect("energysplash", locations[index], location, 0)
    if effect == "sparks":
        es.effect("sparks", locations[index], 1, 5, location)
    if effect == "beam":
        beam = es.precachemodel("sprites/crystal_beam1.vmt")
        es.effect("beam", locations[index], location, beam, beam, 0, 0, 0.7, 10, 10, 0.5, 1, 255, 255, 255, 255, 30)
    if effect == "beacon":
        (x, y, z) = es.splitvectorstring(location)
        es.server.cmd('est_effect 10 #all 0 "sprites/lgtning.vmt" %s %s %s 0 50 1 1 1 1 0 255 0 255 0' % (x, y, z))
    ###############
    locations[index] = location

def clear():
    global locations
    global entities
    for index in locations:
        del locations[index]
    for index in entities:
        del entities[index]
    for grenade in grenades:
        for index in es.createentitylist("%s_projectile" % grenade):
            es.server.cmd("es_remove %s" % index)

def smokegrenade_detonate(event_var):
    gamethread.delayed(10, removeidlesmoke, event_var["userid"])

def round_start(event_var):
    clear()

def removeidlesmoke(userid):
    for index in es.createentitylist("smokegrenade_projectile"):
        if es.getuserid(es.getindexprop(index, "CBaseGrenade.m_hThrower")) == int(userid):
            es.server.cmd("es_remove %s" % index)

def ticklistener():
    global entities
    global locations
    try:
        for grenade in grenades:
            for index in es.createentitylist("%s_projectile" % grenade):
                createeffect(index, grenade)
                if not index in entities:
                    entities[index] = 1
        entitylist = []
        for grenade in grenades:
            for index in es.createentitylist("%s_projectile" % grenade):
                entitylist.append(int(index))
        deleted = []
        for index in entities:
            if not int(index) in entitylist:
                deleted.append(index)
        for index in deleted:
            if index in entities:
                del entities[index]
            if index in locations:
                del locations[index]
    except Exception, e:
        es.dbgmsg(0, "NadeTrail Error:", str(e))

def help(userid):
    if popuplib.isqueued("p_help", userid):
        popuplib.close("p_help", userid)
    p_help = popuplib.create("p_help")
    p_help.addline("-NadeTrail-")
    p_help.addline("-------------------")
    p_help.addline("Author: JoeyT2008")
    p_help.addline("Version: %s" % es.ServerVar("nadetrail_ver"))
    if effect_hegrenade in effects:
        p_help.addline("HE Grenade: %s" % effect_hegrenade)
    else:
        p_help.addline("HE Grenade: %s (CUSTOM)" % effect_hegrenade)
    if effect_flashbang in effects:
        p_help.addline("FlashBang: %s" % effect_flashbang)
    else:
        p_help.addline("FlashBang: %s (CUSTOM)" % effect_flashbang)
    if effect_smokegrenade in effects:
        p_help.addline("Smoke Grenade: %s" % effect_smokegrenade)
    else:
        p_help.addline("Smoke Grenade: %s (CUSTOM)" % effect_smokegrenade)
    p_help.addline("-------------------")
    p_help.addline("0. Close")
    p_help.send(userid)